import 'package:flutter_apns/flutter_apns.dart';
import 'package:plain_notification_token/plain_notification_token.dart';
import 'package:tim_ui_kit_push_plugin/channel/flutter_push_base_impl.dart';

import '../tim_ui_kit_push_plugin.dart';

class AppleAPNSImpl extends FlutterPushBase{
  final PushConnector applePushConnector = createPushConnector();
  final PlainNotificationToken getAppleNotificationToken = PlainNotificationToken();

  @override
  void init(PushClickAction onClickNotificationFunction){
    applePushConnector.configure(
      onLaunch: (RemoteMessage message) async {
        onClickNotificationFunction(message.data);
        return;
      },
      onResume: (RemoteMessage message) async {
        onClickNotificationFunction(message.data);
        return;
      },
    );
  }

  @override
  Future<String?> getToken() async {
    getAppleNotificationToken.requestPermission();
    await getAppleNotificationToken.onIosSettingsRegistered.first;
    return await getAppleNotificationToken.getToken();
  }

  @override
  void requirePermission() {
    applePushConnector.requestNotificationPermissions();
  }

  @override
  bool isSupport() {
    return true;
  }
}