import 'package:flutter/services.dart';
import 'package:huawei_push/huawei_push.dart';
import 'package:tim_ui_kit_push_plugin/channel/flutter_push_base_impl.dart';
import 'package:tim_ui_kit_push_plugin/tim_ui_kit_push_plugin.dart';

class HuaweiImpl extends FlutterPushBase{

  @override
  Future<String?> getToken() async {
    return token;
  }

  @override
  void init(PushClickAction onClickNotificationFunction) {
    onClickNotification = onClickNotificationFunction;
    initHuaweiNotificationListener();
    initHuaweiTokenStream();
  }

  @override
  void requirePermission() {
    // TODO: implement requirePermission
  }

  Future<void> initHuaweiTokenStream() async {
    print("TUIKitPush | Dart | HUAWEI | init");
    bool result = await Push.isAutoInitEnabled();
    Push.getToken("");
    Push.getTokenStream.listen(_onHuaweiTokenEvent, onError: _onHuaweiTokenError);
  }

  Future<void> initHuaweiNotificationListener() async {
    Push.onNotificationOpenedApp.listen(_onHaweiNotificationOpenedApp);
  }

  void _onHaweiNotificationOpenedApp(remoteMessage) {
    print("onHUAWEINotificationOpenedApp: " + remoteMessage["extras"].toString());
    onClickNotification!(remoteMessage["extras"]);
  }

  void _onHuaweiTokenEvent(String event) {
    // Requested tokens can be obtained here
    token = event;
    print("HuaweiTokenEvent: " + token);
  }

  void _onHuaweiTokenError(Object error) {
    PlatformException e = error as PlatformException;
    print("HuaweiTokenErrorEvent: ${e.message}");
  }

  @override
  bool isSupport() {
    return true;
  }
  
}